﻿@using WebNotesView.Services
@inherits MainLayoutBase
@inject IBootstrapCSS BootstrapCSS
@inject StateService State

<BSNavbar IsFixedTop="true" IsDark="true" Class="navbar-expand flex-column flex-md-row bd-navbar">

    @*<a class="navbar-brand mr-0 mr-md-2" href="/" aria-label="Web Notes">
            <img src="_content/SampleCore/logo-inverted.svg" width="36" height="36" alt="WebNotes">
        </a>*@
    <BSNavbarBrand>Web Notes</BSNavbarBrand>
    <div class="navbar-nav-scroll">
        <BSNav IsList="true" class="navbar-nav bd-navbar-nav flex-row">
            <BSNavItem>
                <BSNavLink Href="/">Home</BSNavLink>
            </BSNavItem>

            @*<BSNavItem IsDropdown="true">
                    <BSDropdownToggle Color="Color.Light" IsLink="true">Themes</BSDropdownToggle>
                    <ThemeSwitcher IsDropDown="true" />
                </BSNavItem>*@
        </BSNav>
    </div>


    @*<ul class="navbar-nav flex-row ml-md-auto d-none d-md-flex">
            <li class="nav-item">
                <a class="nav-link p-2" href="https://github.com/chanan/BlazorStrap" target="_blank" rel="noopener" aria-label="GitHub"><svg xmlns="http://www.w3.org/2000/svg" class="navbar-nav-svg" viewBox="0 0 512 499.36" role="img" focusable="false"><title>GitHub</title><path fill="currentColor" fill-rule="evenodd" d="M256 0C114.64 0 0 114.61 0 256c0 113.09 73.34 209 175.08 242.9 12.8 2.35 17.47-5.56 17.47-12.34 0-6.08-.22-22.18-.35-43.54-71.2 15.49-86.2-34.34-86.2-34.34-11.64-29.57-28.42-37.45-28.42-37.45-23.27-15.84 1.73-15.55 1.73-15.55 25.69 1.81 39.21 26.38 39.21 26.38 22.84 39.12 59.92 27.82 74.5 21.27 2.33-16.54 8.94-27.82 16.25-34.22-56.84-6.43-116.6-28.43-116.6-126.49 0-27.95 10-50.8 26.35-68.69-2.63-6.48-11.42-32.5 2.51-67.75 0 0 21.49-6.88 70.4 26.24a242.65 242.65 0 0 1 128.18 0c48.87-33.13 70.33-26.24 70.33-26.24 14 35.25 5.18 61.27 2.55 67.75 16.41 17.9 26.31 40.75 26.31 68.69 0 98.35-59.85 120-116.88 126.32 9.19 7.9 17.38 23.53 17.38 47.41 0 34.22-.31 61.83-.31 70.23 0 6.85 4.61 14.81 17.6 12.31C438.72 464.97 512 369.08 512 256.02 512 114.62 397.37 0 256 0z"></path></svg></a>
            </li>
        </ul>*@
    <ul class="navbar-nav flex-row ml-md-auto d-none d-md-flex">
        <li class="nav-item">
            <button class="btn d-none d-lg-inline-block mb-3 mb-md-0 ml-md-3" @onclick=@(()=> ToggleTheme())>theme</button>
        </li>
    </ul>
</BSNavbar>

<BSContainer IsFluid="true" Style="padding:0">
    <BSRow NoGutters="true">

        <BSCol XS="12" MD="3" XL="2" Class="bd-sidebar">
            <NavigationMenu />
        </BSCol>

        <BSCol XS="12" MD="9" XL="8">
            <BSContainer Class="py-md-3 pl-md-5 bd-content" role="main">
                @Body
            </BSContainer>
        </BSCol>
    </BSRow>
</BSContainer>

<BSNavbar IsFixedBottom="true" IsDark="true" IsExpand="true" Class="navbar-expand flex-column flex-md-row">
    <BSLabel>Made with Blazor</BSLabel>
</BSNavbar>

@code
{
    private bool IsSidebarDocked = true;
    private bool hasBeendone = false;

    private Theme currentTheme = Theme.Darkly;

    private void Dock()
    {
        IsSidebarDocked = !IsSidebarDocked;
    }

    protected async override Task OnAfterRenderAsync(bool firstRender)
    {
        if (!this.hasBeendone)
        {
            await this.ApplyTheme();
        }
    }

    private async Task ToggleTheme()
    {
        if (currentTheme == Theme.Darkly)
        {
            this.currentTheme = Theme.Materia;
        }
        else
        {
            this.currentTheme = Theme.Darkly;
        }

        await this.ApplyTheme();
        this.StateHasChanged();
    }


    private async Task ApplyTheme()
    {
        await BootstrapCSS.SetBootstrapCSS(this.currentTheme, "4.3.1");
        this.hasBeendone = true;
    }
}
